SystemOrganization addCategory: #Geometry!
SystemOrganization addCategory: 'Geometry-Test'!

TestCase subclass: #GCircleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:42'!
testBoundaryContains
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) boundaryContains: 2 @ 2)
		equals: false! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:42'!
testBoundaryContains1
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) boundaryContains: 5 @ 2)
		equals: true! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:42'!
testContains
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) contains: 2 @ 2)
		equals: true! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:42'!
testContains1
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) contains: 6 @ 2)
		equals: false! !

TestCase subclass: #GLineTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 17:24'!
testIntersect
self
	assert: ((GLine a: 2 b: -3 c: 0.5) intersect: (GLine a: 1 b: 1 c: -2))
	equals: 1.1 @ 0.9! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 17:37'!
testIntersect1
self
	assert: ((GLine a: 2 b: -3 c: 0.5) intersect: (GLine a: -2 b: -2 c: 4))
	equals: 1.1 @ 0.9! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 20:22'!
testParallelTo
self
	assert: ((GLine a: 0 b: -3 c: 0.5) parallelTo: (GLine a: -2 b: 0 c: 4))
	equals: false.
self
	assert: ((GLine a: 0 b: -3 c: 0.5) parallelTo: (GLine a: -2 b: 1 c: 4))
	equals: false.
self
	assert: ((GLine a: 1 b: 2 c: 0.5) parallelTo: (GLine a: 2 b: 4 c: 4))
	equals: true.
self
	assert: ((GLine a: 0 b: 2 c: 0.5) parallelTo: (GLine a: 0 b: 2 c: 0.5))
	equals: true.! !

TestCase subclass: #GSegmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 18:02'!
testAsLine
|line|
	line := (GSegment with:  1 @ 3 with: 3 @ 0) asLine .
	self assert: line a equals: 3.
	self assert: line b equals: 2.
	self assert: line c equals: -9.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:25'!
testAsLine1
|line|
	line := (GSegment with:  -2 @ 4 with: 2 @ 4) asLine .
	self assert: line a equals: 0.
	self assert: line b equals: 1.
	self assert: line c equals: -4.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 18:05'!
testAsLine2
|line|
	line := (GSegment with:  1 @ 3 with: 1 @ 0) asLine .
	self assert: line a equals: 1.
	self assert: line b equals: 0.
	self assert: line c equals: -1.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:24'!
testBelowPoint
self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) belowPoint: -2 @ 4 ) 
	equals: false.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:28'!
testBelowPoint1

self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) belowPoint: 0 @ 5 ) 
	equals: true.
self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) belowPoint: 0 @ -5 ) 
	equals: false.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:46'!
testBelowPoint2
self assert:((GSegment with:  -2 @ 4 with: -2 @ 0) belowPoint: 0 @ 2 ) 
	equals: true.
self assert:((GSegment with:  -2 @ 4 with: -2 @ 0) belowPoint: -4 @ 2 ) 
	equals: false.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:16'!
testHasPoint

	self assert:((GSegment with:  1 @ 3 with: 3 @ 0) hasPoint: 1 @ 3)
   		equals: true.
	self assert:((GSegment with:  1 @ 3 with: 3 @ 0) hasPoint: 3 @ 0)
   		equals: true.
	self assert:((GSegment with:  -1 @ 1 with: 1 @ -1) hasPoint: 0 @ 0)
   		equals: true.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 11:18'!
testIntersect
	self
		assert: ((GSegment with: -1 @ -1 with: 1 @ 1) intersect:(GSegment with: -1 @ 1 with: 1 @ -1))
		equals: 0 @ 0! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 16:19'!
testIntersect1
	self
		assert: ((GSegment with: -1 @ -1 with: 1 @ 1) intersect:(GSegment with: -3 @ 3 with: -1 @ 1))
		equals: nil! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:48'!
testLength
	self
		assert: (GSegment with: 0 @ 0 with: 3 @ 4) length
		equals: 5! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/22/2014 16:20'!
testLength1
	self
		assert: (GSegment with: -2 @ 1 with: 3 @ 4) length
		equals: 34 sqrt! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/21/2014 12:49'!
testMidPoint
	self
		assert: (GSegment with: -1 @ 2 with: 2 @ 1) midPoint 
		equals: 0.5 @ 1.5! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/22/2014 16:21'!
testMidPoint1
	self
		assert: (GSegment with: 2 @ 1 with: 2 @ 1) midPoint 
		equals: 2 @ 1! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 16:58'!
testPerpendicularBisector
	self
		assert: (GSegment with: -1 @ 2 with: 0 @ 0) perpendicularBisector a
		equals: 1! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 17:33'!
testPerpendicularBisector1
|line|
	line := (GSegment with: 1 @ 3 with: -1 @ 1) perpendicularBisector. 
		self assert: line a equals: -2.
		self assert: line b equals: -2.
		self assert: line c equals: 4.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 16:58'!
testPerpendicularBisector2
	self
		assert: (GSegment with: -1 @ 2 with: 0 @ 0) perpendicularBisector b
		equals: -2! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 17:36'!
testPerpendicularBisector3
|line|
	line := (GSegment with: 3 @ 0 with: 1 @ 3)  perpendicularBisector. 
		self assert: line a equals: -2.
		self assert: line b equals: 3.
		self assert: line c equals: -1/2.! !

TestCase subclass: #GTriangleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:51'!
testArea
	self
		assert:
			((GTriangle with: 0 @ 0 with: 2 @ 0 with: 0 @ 2) area closeTo: 2)! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/22/2014 16:21'!
testCircumscribedCircle
	| circle |
	circle := (GTriangle with: -1 @ 2 with: 0 @ 0 with: 2 @ 1) circumscribedCircle.
	self assert: circle center equals: 0.5 @ 1.5.
	self assert: (circle radius closeTo: 10 sqrt / 2)
	

! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 19:06'!
testCircumscribedCircle1
	| circle |
	circle := (GTriangle with: -1 @ 1 with: 3 @ 0 with: 1 @ 3) circumscribedCircle.
	self assert: circle center equals: (11/10) @ (9/10).
	self assert: (circle radius closeTo: (1+(21*21)) sqrt / 10)
	

! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 21:55'!
testCircumscribedCircle2
	| circle |
	circle := (GTriangle with: -1 @ 1 with: 2 @ 3  with: 5 @ -3) circumscribedCircle.
	self assert: circle center equals: (9 / 4) @ (-5 / 8).
	self assert: (circle radius closeTo: (5 sqrt)* 13 / 8 )
! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 20:30'!
testCircumscribedCircle3
	| circle |
	circle := (GTriangle with: 2 @ 3 with: 7 @ 4 with: 5 @ 7) circumscribedCircle.
	self assert: circle center equals: (147/34) @ (149/34).

	

! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:41'!
testPerimeter
	self
		assert: (GTriangle with: 0 @ 0 with: 2 @ 0 with: 0 @ 2) perimeter
		equals: 4 + 8 sqrt! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:41'!
testSemiperimeter
	self
		assert: (GTriangle with: 0 @ 0 with: 2 @ 0 with: 0 @ 2) semiperimeter
		equals: 2 + 2 sqrt! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/18/2014 13:55'!
sideWhichHas: point
|s1 s2 s3 s4|
self halt.
s1:= GSegment with: (self origin ) with: (self origin x @ self corner y). 
s2:= GSegment with: (self origin x @ self corner y) with: (self corner).
s3:= GSegment with: (self corner ) with: (self corner x @ self origin y).
s4:= GSegment with: (self origin x @ self corner y )with:  (self origin).

(s1 hasPoint: point) ifTrue: [^s1]	ifFalse:[ 
		(s2 hasPoint: point) ifTrue: [^s2] ifFalse:[
		(s3 hasPoint: point) ifTrue: [^s3] ifFalse:[
		(s4 hasPoint: point) ifTrue: [^s4] ifFalse:[^nil]
	]]]! !

Object subclass: #GCircle
	instanceVariableNames: 'center radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GCircle commentStamp: 'NataliaTymchuk 5/15/2014 19:13' prior: 0!
I am a circle. I have a center and radius!

!GCircle class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:49'!
center: aPoint1 radius: aNumber
	^ self new initializeWithCenter: aPoint1 radius: aNumber! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:41'!
boundaryContains:aPoint
^(self radius = (self center dist: aPoint)) 
! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:50'!
center

^center ! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:41'!
contains:aPoint
^(self radius > (self center dist: aPoint)) ! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:48'!
initializeWithCenter: aPoint1 radius: aNumber
	super initialize.
	center := aPoint1.
	radius := aNumber.! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:51'!
radius

^radius ! !

Object subclass: #GLine
	instanceVariableNames: 'a b c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GLine commentStamp: 'NataliaTymchuk 5/21/2014 11:34' prior: 0!
A GLine has 3 instance variables, which are koeficients  of line:
ax+by+c=0

!

!GLine class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/21/2014 11:33'!
a: aNumber1 b: aNumber2 c: aNumber3
	^ self new initializeWithA: aNumber1 b: aNumber2 c: aNumber3! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/21/2014 11:32'!
a
	^a
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:46'!
b
	^b
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/21/2014 11:32'!
c
	^c
! !

!GLine methodsFor: 'initialization' stamp: 'NataliaTymchuk 5/21/2014 11:33'!
initializeWithA: aNumber1 b: aNumber2 c: aNumber3
	super initialize.
	a := aNumber1.
	b := aNumber2.
	c := aNumber3.! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 20:18'!
intersect: aGLine 
	| xi yi |

	(self parallelTo: aGLine) ifTrue: [ ^ nil ].
					
	yi := (self c * (aGLine a) - (self a * (aGLine c)))
			/ 
			(self a * (aGLine b) - (self b * (aGLine a))).

	xi := self a isZero
		ifTrue: [
			 ( aGLine b * yi + (aGLine c)) negated / (aGLine a)]
		ifFalse: [
			 ( self b * yi + self c) negated / self a].
	
	^xi@yi.



! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/18/2014 17:04'!
intersectRectangle: rect
| c1 c2 c3 c4 coll  s1 s2 s3 s4|
	coll:=OrderedCollection new.
	s1:=(GSegment with: rect origin  with: (rect origin x @ rect corner y)).
	c1:= s1 intersectLine: self.
	c1 ifNotNil: [(s1 hasPoint:c1)ifTrue:[ coll add: c1 ]].
	
	s2:=(GSegment with: (rect origin x @ rect corner y) with: rect corner).
	c2:= s2 intersectLine: self.
	c2 ifNotNil: [(s2 hasPoint:c2)ifTrue:[ coll add: c2 ]].
	
	s3:=(GSegment with: rect corner  with: (rect corner x @ rect origin y)).
	c3:= s3 intersectLine: self.
	c3 ifNotNil: [(s3 hasPoint:c3)ifTrue:[ coll add: c3 ]].
	
	s4:=(GSegment with: (rect corner x @ rect origin y) with:  rect origin).
	c4:= s4 intersectLine: self.
	c4 ifNotNil: [(s4 hasPoint:c4)ifTrue:[ coll add: c4 ]].
	^coll ! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:46'!
k
	^k
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 20:18'!
parallelTo: aLine

	^ (self a isZero & aLine a isZero) or:
	[ (self b isZero & aLine b isZero) or:
	[ (aLine a isZero | aLine b isZero) not and:
	[ (self a / aLine a) = (self b / aLine b) ] ] ]! !

Object subclass: #GSegment
	instanceVariableNames: 'v1 v2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GSegment commentStamp: 'NataliaTymchuk 5/15/2014 19:46' prior: 0!
I am a segment between two vertices!

!GSegment class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:46'!
with: aPoint1 with: aPoint2
	^ self new initializeWith: aPoint1 with: aPoint2! !

!GSegment methodsFor: 'initialization' stamp: 'NataliaTymchuk 6/12/2014 15:25'!
= segment

^
((self v1 = segment v1) and: [self v2 = segment v2]) 
or: 
[(self v1 = segment v2) and: [self v2 = segment v1]]! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/11/2014 17:56'!
asLine
|ai bi ci|
(self v1 y) = (self v2 y) ifTrue:
[ ^ GLine
		a: 0 b: 1 c: ((self v1 y) negated)].
(self v1 x) = (self v2 x) ifTrue:[ 
	^ GLine
		a: 1 b: 0 c: ((self v1 x) negated)].	
ai := (self v1 y) - (self v2 y). 
bi := (self v2 x) - (self v1 x).
ci := ((self v1 x) - (self v2 x)) * (self v1 y) + ( ((self v2 y) - (self v1 y)) * (self v1 x) ).
^ GLine
		a:ai b: bi c: ci! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:25'!
belowPoint:p
^( (self v2 x - self v1 x)*(p y - self v1 y)-((self v2 y - self v1 y)*(p x - self v1 x))> 0 )
	
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/15/2014 17:56'!
boundBy: aPoint
	^ self v1 = aPoint or: [ self v2 = aPoint ]! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/17/2014 15:16'!
hasPoint:aPoint

  ^( (self v1 x <= aPoint x and: [aPoint x <= self v2 x])  or:
		[self v2 x <= aPoint x and: [aPoint x <= self v1 x]]  ) and: 
   [ (self v1 y <= aPoint y and: [aPoint y <= self v2 y])  or:
		[self v2 y <= aPoint y and: [aPoint y <= self v1 y]]   ]  .
   
! !

!GSegment methodsFor: 'initialization' stamp: 'NataliaTymchuk 6/12/2014 16:04'!
hash
^( v1 hash  + v2 hash ) hashMultiply! !

!GSegment methodsFor: 'initialization' stamp: 'NataliaTymchuk 5/15/2014 19:46'!
initializeWith: aPoint1 with: aPoint2
	super initialize.
	v1 := aPoint1.
	v2 := aPoint2! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/17/2014 16:42'!
intersect:aSegment

(self v1 to: self v2 intersects: aSegment v1 to: aSegment v2) 
	ifTrue:	[^self asLine intersect: (aSegment asLine)]
	ifFalse: [^nil]
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/18/2014 15:23'!
intersectLine:aLine
| |

^self asLine intersect: aLine.

! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 5/15/2014 19:49'!
length
	^ v1 dist: v2! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/18/2014 22:31'!
locationOf: aPoint
    
    ^ ((self v2 x - self v1 x) * (aPoint y - self v1 y) - 
      ((self v2 y - self v1 y) * (aPoint x - self v1 x))) sign! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 5/20/2014 11:30'!
midPoint
|a b|
 a := (v1 x + v2 x) / 2.

 b := (v1 y + v2 y) / 2.

^a@b! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/11/2014 16:32'!
perpendicularBisector

^GLine
a:  (v2 x - v1 x)
b:  (v2 y - v1 y)
c: ((v1 x * v1 x) - (v2 x * v2 x) + (v1 y * v1 y) - (v2 y * v2 y))/2
! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/15/2014 15:25'!
printOn: aStream
	v1 printOn: aStream.
	aStream nextPutAll: '>-<'.
	v2 printOn: aStream! !

!GSegment methodsFor: 'accessing' stamp: 'NataliaTymchuk 5/20/2014 11:05'!
v1
^v1

! !

!GSegment methodsFor: 'accessing' stamp: 'NataliaTymchuk 5/20/2014 11:06'!
v2
^v2

! !

!GSegment methodsFor: 'initialization' stamp: 'NataliaTymchuk 6/15/2014 13:03'!
vertices
	^ { v1 . v2 }! !

Object subclass: #GTriangle
	instanceVariableNames: 'v1 v2 v3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GTriangle commentStamp: 'NataliaTymchuk 5/15/2014 19:07' prior: 0!
I am a triangle!

!GTriangle class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:10'!
with: aPoint1 with: aPoint2 with: aPoint3
	^ self new initializeWith: aPoint1 with: aPoint2 with: aPoint3! !

!GTriangle methodsFor: 'properties' stamp: 'NataliaTymchuk 5/21/2014 12:37'!
area
	| semiperimeter|
	semiperimeter := self semiperimeter.

	^ (self edges 
		inject: semiperimeter
		into: [ :subProduct :edge |
			semiperimeter - edge length * subProduct ]) sqrt! !

!GTriangle methodsFor: 'figures' stamp: 'NataliaTymchuk 5/21/2014 13:03'!
circumscribedCircle

	^ GCircle
		center:
			(self edges first perpendicularBisector intersect:
			 self edges last perpendicularBisector)
		radius: (v1 dist: v2) * (v2 dist: v3) * (v3 dist: v1) / (4 * self area)! !

!GTriangle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:45'!
edges
	^ { 
		GSegment with: v1 with: v2 .
		GSegment with: v2 with: v3 .
		GSegment with: v3 with: v1
	}! !

!GTriangle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:09'!
initializeWith: aPoint1 with: aPoint2 with: aPoint3
	super initialize.
	v1 := aPoint1.
	v2 := aPoint2.
	v3 := aPoint3 ! !

!GTriangle methodsFor: 'properties' stamp: 'NataliaTymchuk 5/15/2014 19:49'!
perimeter
	^ self edges
		inject: 0
		into: [ :subSum :edge |
			subSum + edge length ]! !

!GTriangle methodsFor: 'properties' stamp: 'NataliaTymchuk 5/15/2014 19:50'!
semiperimeter
	^ self perimeter / 2! !

Object subclass: #GVector
	instanceVariableNames: 'originPoint directionPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GVector commentStamp: 'NataliaTymchuk 6/3/2014 13:39' prior: 0!
I am a vector builded on line ax+by+c=0 and have my start in point v1.
	- xxxxx

v1
	- xxxxx
!

!GVector class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/16/2014 21:01'!
with: aPoint1 with: aPoint2
	^ self new initializeWith: aPoint1 with: aPoint2! !

!GVector methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/16/2014 21:05'!
asLine
|ai bi ci|
(self originPoint  y) = (self directionPoint  y) ifTrue:
[ ^ GLine
		a: 0 b: 1 c: ((self originPoint y) negated)].
(self originPoint x) = (self directionPoint x) ifTrue:[ 
	^ GLine
		a: 1 b: 0 c: ((self originPoint x) negated)].	
ai := (self originPoint y) - (self directionPoint y). 
bi := (self directionPoint x) - (self originPoint x).
ci := ((self originPoint x) - (self directionPoint x)) * (self originPoint y) + ( ((self directionPoint y) - (self originPoint y)) * (self originPoint x) ).
^ GLine
		a:ai b: bi c: ci
! !

!GVector methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/5/2014 19:53'!
directionPoint
	^directionPoint 
! !

!GVector methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/16/2014 21:00'!
initializeWith: aPoint1 with: aPoint2
	super initialize.
	originPoint  := aPoint1.
	directionPoint  := aPoint2 
! !

!GVector methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/16/2014 21:02'!
length
	^ directionPoint dist: originPoint
! !

!GVector methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/5/2014 19:53'!
originPoint 
	^originPoint 
! !
